﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Drawing.Imaging;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace malovani
{
    public partial class Form1 : Form
    {
        private Pen p;
        private Brush b;
        private int cnt = 1;

        private int X0, Y0;
        private bool s = false;
        private Bitmap save;

        public Form1()
        {
            InitializeComponent();
            pictureBox1_SizeChanged (null, null);
            p = new Pen(panel1.BackColor);
            b = new SolidBrush (panel1.BackColor);
            // toolPanel.MouseDown += panel1_MouseDown;
            comboBox1.SelectedIndex = 0;
        }

        private void panel1_Click(object sender, EventArgs e)
        {
            // p = new Pen (panel1.BackColor);
            p = new Pen((sender as Panel).BackColor);
        }

        private void panel1_MouseDown (object sender, MouseEventArgs e)
        {
            // Panel t = (Panel) sender;
            // Panel t = sender as Panel;
            Control t = (Control) sender;

            if (e.Button == MouseButtons.Middle)
            {
                colorDialog1.Color = t.BackColor;
                if (colorDialog1.ShowDialog() == DialogResult.OK)
                {
                    t.BackColor = colorDialog1.Color;
                    p = new Pen (t.BackColor);
                }
            }
            else if (e.Button == MouseButtons.Left)
            {
                p = new Pen (t.BackColor);
            }
            else if (e.Button == MouseButtons.Right)
            {
                b = new SolidBrush (t.BackColor);
            }
        }

        private void newColorToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Panel t = new Panel();
            t.Parent = toolPanel;
            t.BackColor = Color.CornflowerBlue;

            t.Width = panel1.Width;
            t.Height = panel1.Height;
            t.Top = panel1.Top;
            cnt++;
            t.Left = cnt * panel1.Left + (cnt - 1) * panel1.Width;

            t.MouseDown += panel1_MouseDown;
            p = new Pen (t.BackColor);
        }

        private void pictureBox1_SizeChanged(object sender, EventArgs e)
        {
            Image old = pictureBox1.Image;

            int w = pictureBox1.Width;
            int h = pictureBox1.Height;

            if (old != null)
            {
                w = Math.Max (w, old.Width);
                h = Math.Max (h, old.Height);
            }

            pictureBox1.Image = new Bitmap (w, h);
            Graphics g = Graphics.FromImage(pictureBox1.Image);
            Brush b = new SolidBrush(Color.White);
            g.FillRectangle (b, 0, 0, w, h);

            if (old != null)
               g.DrawImage (old, 0, 0);
        }

        private void testToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Graphics g = Graphics.FromImage (pictureBox1.Image);
            Pen p = new Pen (Color.Red);
            g.DrawLine (p, 10, 10, 100, 100);
            pictureBox1.Invalidate();
        }

        private void pictureBox1_MouseDown(object sender, MouseEventArgs e)
        {
            X0 = e.X;
            Y0 = e.Y;
            s = true;
            save = new Bitmap (pictureBox1.Image);
        }

        private void pictureBox1_MouseMove(object sender, MouseEventArgs e)
        {
            if (s)
            {
                Graphics g = Graphics.FromImage(pictureBox1.Image);
                g.DrawImage (save, 0, 0);
                int n = comboBox1.SelectedIndex;
                if (n == 2)
                    g.DrawLine(p, X0, Y0, e.X, e.Y);
                else
                {
                    int X1 = X0;
                    int Y1 = Y0;
                    int X2 = e.X;
                    int Y2 = e.Y;
                    if (X2 < X1) { int t = X1; X1 = X2; X2 = t; }
                    if (Y2 < Y1) { int t = Y1; Y1 = Y2; Y2 = t; }

                    /*
                    Brush b = new SolidBrush (Color.Yellow);
                    // using System.Drawing.Drawing2D;
                    b = new LinearGradientBrush (new Point (0, 0),
                                                 new Point (100, 100),
                                                 Color.Red,
                                                 Color.Blue);
                    */
                    if (n == 0)
                    {
                        g.FillEllipse(b, X1, Y1, X2 - X1, Y2 - Y1);
                        g.DrawEllipse(p, X1, Y1, X2 - X1, Y2 - Y1);
                    }
                    else
                    {
                        g.FillRectangle(b, X1, Y1, X2 - X1, Y2 - Y1);
                        g.DrawRectangle(p, X1, Y1, X2 - X1, Y2 - Y1);
                    }

                }

                pictureBox1.Invalidate();
            }
        }

        private void pictureBox1_MouseUp(object sender, MouseEventArgs e)
        {
            s = false;
        }

        private void newObjectToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Panel t = new Panel ();
            t.Parent = pictureBox1;
            t.BackColor = Color.Blue;

            t.MouseDown += panel_MouseDown;
            t.MouseMove += panel_MouseMove;
            t.MouseUp += panel_MouseUp;

            Button u = new Button();
            u.Parent = t;
            u.BackColor = SystemColors.Control;
            u.Left = 8;
            u.Top = 8;
            u.Click += button_Click;
        }

        bool q = false;

        private void button_Click (object sender, EventArgs e)
        {
            Button u = (Button) sender;
            Panel t = (Panel) u.Parent;
            ImageLayout v = t.BackgroundImageLayout;
            if (v == ImageLayout.Zoom)
                v = ImageLayout.None;
            else
               v ++;
            t.BackgroundImageLayout = v;
        }

        private void panel_MouseDown(object sender, MouseEventArgs e)
        {
            q = true;
            X0 = e.X;
            Y0 = e.Y;

            if (e.Button == MouseButtons.Middle)
            {
               Panel t = (Panel) sender;
               if (Control.ModifierKeys == Keys.Control)
               {
                   colorDialog1.Color = t.BackColor;
                   if (colorDialog1.ShowDialog() == DialogResult.OK)
                       t.BackColor = colorDialog1.Color;
               }
               else
               {
                   if (openFileDialog1.ShowDialog() == DialogResult.OK)
                   {
                       Bitmap u = new Bitmap (openFileDialog1.FileName);
                       t.BackgroundImage = u;
                       // t.BackgroundImageLayout = ImageLayout.Stretch;
                   }
               }
            }
        }

        private void panel_MouseMove(object sender, MouseEventArgs e)
        {
            if (q)
            {
                Panel t = (Panel) sender;
                if (e.Button == MouseButtons.Left)
                {
                    t.Left += e.X - X0;
                    t.Top += e.Y - Y0;
                }
                else if (e.Button == MouseButtons.Right)
                {
                    t.Width += e.X - X0;
                    t.Height += e.Y - Y0;
                    X0 = e.X;
                    Y0 = e.Y;
                }
            }
        }

        private void panel_MouseUp(object sender, MouseEventArgs e)
        {
            q = false;
        }

        private void open_Click(object sender, EventArgs e)
        {
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                Bitmap p = new Bitmap (openFileDialog1.FileName);
                pictureBox1.Image = p;
                pictureBox1_SizeChanged (null, null);
            }
        }

        private void save_Click(object sender, EventArgs e)
        {
            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                // using System.Drawing.Imaging;
                if (saveFileDialog1.FilterIndex == 1)
                   pictureBox1.Image.Save(saveFileDialog1.FileName, ImageFormat.Bmp);
                else
                    pictureBox1.Image.Save(saveFileDialog1.FileName, ImageFormat.Jpeg);
            }
        }



    }
}
